//@ sourceURL=role_manage.js
$(function () {
    //新增按钮点击事件
    $("#btn_add").click(function (t) {
        $("#editModal").modal();
        $("#classTitle").text("新增");
        clearInput();
        getRoleMenu();
    });
    //角色保存按钮点击事件
    $("#btn_save").click(function (t) {
        var validatorResult = validator.checkAll($("#editRoleForm"));
        if (validatorResult) {
            saveRole();
        }
    });
    //初始化表格数据
    getAllRole();
});

/**
 * 下拉权限菜单树
 */
//生成权限菜单树
function getRoleMenu(role_id){
    var str = "";
    if(role_id != null){
        str = "?role_id="+role_id;
    }
    $.ajax({
        type: "GET",
        url: '/thmz/getRoleMenuTree'+str,
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view';
                return;
            }
            if (res.code == 0) {
                //初始化ztree
                $.fn.zTree.init($("#relationTree"),{
                    view: {
                        showIcon: false   //隐藏节点图标
                    },
                    check: {
                        enable: true,
                        chkStyle: "checkbox"
                    },
                    data: {
                        simpleData: {
                            enable: true,
                            idKey:"id",
                            pIdKey:"pId",
                            rootPId:0
                        }
                    },
                    callback: {
                        //选中以后执行的方法，此方法除了onCheck还有onClick等 此方法中用于定义自己的业务
                        onCheck: function(e, treeId, treeNode) {
                            var zTree = $.fn.zTree.getZTreeObj("relationTree"),
                                nodes = zTree.getCheckedNodes(true),
                                v = "",//button 标签显示的内容
                                relationTypeId="";//用于存放上面隐藏select的值
                            if(nodes != null){
                                for(var i=0, l=nodes.length; i<l; i++) {
                                    //拼接选中的内容，name用于显示
                                    v += nodes[i].name + ",";
                                    //由于是多选，给每个option添加selected （注意select的multiple）
                                    relationTypeId+="<option selected value='"+nodes[i].id+"'>"+nodes[i].name+"</option>";
                                }
                            }
                            if(v.length > 0) {
                                v = v.substring(0, v.length-1);
                            };
                            $("#relationTypeId").html(relationTypeId);//将选中的值放到select
                            $('.pull-left1', '#relationBtn').text(v).attr('title', v);//将中文（要显示的内容）放到button中显示
                            if(v == ""){//如果没有选中任何值，显示默认内容
                                $('.pull-left1', '#relationBtn').text('请选择').attr('title', '请选择');
                            }
                        }
                    }
                }, res.data);
                //如果是默认选中某值，调用内部的onCheck()方法，用于将值显示在页面
                $.fn.zTree.getZTreeObj("relationTree").setting.callback.onCheck();
            } else {
                errorMesage(res);
            }
        }
    });
}
//点击按钮 显示或者关闭菜单列表
$('#relationBtn').on('click', function(){
    if($('#relationPanel').is(":visible")){
        $('#relationPanel').hide();
    }else{
        $('#relationPanel').show();
    }
});
//点击空白其他区域隐藏展开的面板
$(document).click(function(e){
    if( $(e.target).attr('id') != "relationPanel" && $(e.target).parents('#relationPanel').length <= 0 &&
        $(e.target).attr('id')!="relationBtn" && $(e.target).parents('#relationBtn').length <= 0 ){
        $('#relationPanel').hide();
    }
});
/**下拉权限菜单树 end*/




/**
 * 保存角色数据
 */
function saveRole() {
    var menus = $("#relationTypeId").val();
    var menuIds=null;
    if(menus!=null && menus.length>0){
        for (var i=0;i<menus.length;i++){
            if(menuIds==null){
                menuIds=menus[i];
            }else {
                menuIds+=","+menus[i];
            }
        }
    }else{
        errorMesage({message:"菜单权限不能为空"});
        return;
    }
    var id = $("#id").val();
    var data = null;
    //修改角色
    if (id != null) {
        data = JSON.stringify({
            role: {
                id: id,
                roleName: $("#roleName").val(),
                remark: $("#remark").val()
            },
            menuIds: menuIds
        });
    } else {
        //新增角色
        data = JSON.stringify({
            role: {
                roleName: $("#roleName").val(),
                remark: $("#remark").val()
            },
            menuIds: menuIds
        });
    }
    $.ajax({
        type: "POST",
        url: '/thmz/saveRoleMenuRelation',
        contentType: "application/json;charset=UTF-8",
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        data: data,
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $("#editModal").modal("hide");
                clearInput();
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}


/**
 * 清空输入框
 */
function clearInput() {
    $("#id").val(null);
    $("#roleName").val(null);
    $('#remark').val(null);
    $('#relationTypeId').val(null);
}


/**
 * 查询角色列表
 */
function getAllRole() {
    $('#tb_table').bootstrapTable("destroy");
    $('#tb_table').bootstrapTable({
        url: '/thmz/getAllRole',         //请求后台的URL（*）
        method: 'post',                      //请求方式（*）
        toolbar: '#toolbar',                //工具按钮用哪个容器
        striped: true,                      //是否显示行间隔色
        cache: false,                       //是否使用缓存，默认为true，所以一般情况下需要设置一下这个属性（*）
        pagination: true,                   //是否显示分页（*）
        sortable: true,                     //是否启用排序
        sortOrder: "asc",                   //排序方式
        queryParams: queryParams,           //传递参数（*）
        sidePagination: "client",           //分页方式：client客户端分页，server服务端分页（*）
        pageNumber: 1,                       //初始化加载第一页，默认第一页
        pageSize: 10,                       //每页的记录行数（*）
        pageList: [10, 25, 50, 100],        //可供选择的每页的行数（*）
        search: false,                       //是否显示表格搜索，此搜索是客户端搜索，不会进服务端，所以，个人感觉意义不大
        strictSearch: true,
        showColumns: false,                  //是否显示所有的列
        showRefresh: false,                  //是否显示刷新按钮
        minimumCountColumns: 2,             //最少允许的列数
        clickToSelect: true,                //是否启用点击选中行
        uniqueId: "ID",                     //每一行的唯一标识，一般为主键列
        showToggle: false,                    //是否显示详细视图和列表视图的切换按钮
        cardView: false,                    //是否显示详细视图
        detailView: false,
        //rowStyle:rowStyle,//通过自定义函数设置行样式
        ajaxOptions: {
            headers: {
                'Accept': 'application/json',
                'Authorization': 'Bearer ' + localStorage.getItem("token")
            }
        },
        columns: [
            {
                title: '操作',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    var str = '<button type="button" class="btn btn-primary  btn-sm" onclick="editRole(' + row.id + ')">编辑</button>';
                    str += '<button type="button" class="btn btn-warning  btn-sm" onclick="deleteRole(' + row.id + ')">删除</button>';
                    return [str].join('');
                }
            },
            {
                field: 'roleName',
                title: '角色名称',
                align: "center",
                valign: 'middle'
            }, {
                field: 'remark',
                title: '备注',
                align: "left",
                valign: 'middle',
            }, {
                field: 'updateTime',
                title: '更新时间',
                align: "center",
                valign: 'middle',
                formatter: function (value, row, index) {
                    return format(value, "yyyy-MM-dd HH:mm:ss");
                }
            }, {
                field: 'updateName',
                title: '更新人',
                align: "center",
                valign: 'middle'
            }
        ],
        responseHandler: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            var ress = eval(res);
            if (ress.code == -1) {
                if (ress.message != null && ress.message != '') {
                    new PNotify({
                        title: '错误提示',
                        text: ress.message,
                        type: 'error',
                        hide: true,
                        styling: 'bootstrap3'
                    });
                }
                return {
                    "total": 0,//总页数
                    "rows": {}   //数据
                };
            }
            return {
                "total": ress.data.length,//总页数
                "rows": ress.data   //数据
            };
        },
    });
}

/**
 * 构建列表查询参数
 * @param params
 * @returns {{mzChargeDetail: {patientId: string | number | string[] | undefined | jQuery, warnDept: string | number | string[] | undefined | jQuery, doctorCode: string | number | string[] | undefined | jQuery, name: string | number | string[] | undefined | jQuery, payMark: number}, beginTime: Date, endTime: Date, pageSize: *, pageIndex: number}}
 */
function queryParams(params) {
    var temp = {
        name: $('#nameParam').val()
    };
    return temp;
};


/**
 * 打开编辑窗口
 * @param id
 */
function editRole(id) {
    $("#classTitle").text("修改");
    $.ajax({
        type: "GET",
        url: '/thmz/getRole?id=' + id,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $("#id").val(res.data.id);
                $("#roleName").val(res.data.roleName);
                $("#remark").val(res.data.remark);
                getRoleMenu(id);
                $("#editModal").modal();
            } else {
                errorMesage(res);
            }
        }
    });

}/**
 * 删除角色
 * @param id
 */
function deleteRole(id) {
    if (!confirm("是否要删除当前角色？")) {
        return;
    }
    $.ajax({
        type: "GET",
        url: '/thmz/deleteRole?role_id=' + id,
        dataType: "json",
        headers: {'Accept': 'application/json', 'Authorization': 'Bearer ' + localStorage.getItem("token")},
        success: function (res) {
            if (res == '401' || res == 401) {
                window.location.href = '/thmz/login/view'
                return;
            }
            if (res.code == 0) {
                $('#tb_table').bootstrapTable('refresh');
                successMesage(res);
            } else {
                errorMesage(res);
            }
        }
    });
}


